//---------------------------------------------------
// module  : Eci.h                         
// auteur  : Max Mignotte                            
// date    :                                              
// langage : C++                                      
// labo    :                                   
//---------------------------------------------------

#if !defined ECI
#define ECI

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include "GibbsSampler.h"
#include "FunctionDen.h"

//------------------------------------------------
// DEFINITIONS -----------------------------------
//------------------------------------------------
#define COLOR_HIST   240
#define COLOR_COURBE 128
#define LENGTH_HISTO   256
#define IMAGE_GREY_LEVEL 256

#define GREY_LEVEL 255
#define WHITE_PIXEL 255
#define BLACK_PIXEL 0

#define ITER       6
#define STOPCOND   0.1     
#define NBECH      3

#define NBCHARS 200
#define BIG_NUMBER 100000

//------------------------------------------------
// CLASSE GIBBSSAMPLER ---------------------------
//------------------------------------------------
class Eci:public GibbsSampler  
{
  //----donnees----
  //---------------
 public:
   float** img_histo;
   float** img_mv;
   float** ppar;

   //Flag
   int FlagEci_silent;
   int flag_ssilent;
 
    //parametre
   int seed;
   int nbiter;
    
 protected:
   //parametres
   float**  pparinit;
   float**  pparmoy;   
   float*** pparstock;

   //histogramme
   float*  histo;
   float   normhisto;

   //----methodes----
   //----------------
 public:
   Eci(int,int,int,int);
   virtual ~Eci();

   void  init_parameter(int**,float**,float*);
   void  init_parameter(int**,float**);
   void  eci_estimate(int**,float**,float*); 
   void  fill_picture(float**,int**);
   void  compute_histo(int**);
 
 protected:
   //--parametres
   void  moypar();
   void  fill_pparstock(int);
   float varpparstock();

   //--procedure eci
   void  compute_parameter(float**,int**);
   void  visu_screen(int,float**);

   //--histogramme
   void  histo_picture(int**);
   void  fill_img_histo();
   void  fill_distribution_mixture();
   float funcgauss(float,float,float,float);
};

#endif 
