//---------------------------------------------------
// module  : GibbsSampler.h                         
// auteur  : Max Mignotte                            
// date    :                                              
// langage : C++                                      
// labo    :                                 
//---------------------------------------------------

#if !defined GIBBS_SAMPLER
#define GIBBS_SAMPLER

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include "FunctionDen.h"

//------------------------------------------------
// CONSTANTES ------------------------------------
//------------------------------------------------
const int   NBPAR=3;

//------------------------------------------------
// CLASSE GIBBSSAMPLER ---------------------------
//------------------------------------------------
class GibbsSampler  
{
  //----donnees------
  //-----------------
  public:
  int** pmatl;
  int** pmatl_init;
  float nrj;

  protected:
  int  length,width; 
  int  nbclass;

  int chgt;
  float*** pmatp;

  //DataNrj
  float Nrj_Prior;
  float Nrj_Likelihood;

  //Flag
  int FlagGS_silent;

  //----methodes-----
  //-----------------
  public:
  GibbsSampler(int,int,int);
  GibbsSampler(GibbsSampler&);
  virtual ~GibbsSampler();

  void  iteration(int**,float**,float*);
  void  iteration(int**,float**,float*,float);
  float compute_nrj(int**,float**,float*);
  float compute_2nrj(int**,float**,float*);

  protected:
  virtual void choose_gibbs_label(int,int);
  virtual float data_connexion_nrj(float**,int**,int,int,int);
  virtual float contextual_nrj(float*,int,int,int);
  virtual float contextual_nrj2(float*,int,int,int);
 
  void  fill_init_matp(int**,float**);  
  void  init_label_matrix_MV();
  float funcgauss(short,float,float,float);
  float randomize();

  int  diff_pmatl(int**,int**);
  void copy_mat(int**,int**);
};

#endif 
