//---------------------------------------------------
// module  : f_Region.cc                         
// auteur  : Max Mignotte                           
// date    :                                              
// langage : C++                                      
// labo    :                                  
//---------------------------------------------------

//-----------------------------------------------
// FICHIERS INCLUS ------------------------------
//-----------------------------------------------
#include "Region.h"

//------------------------------------------------
// METHODES DE LA CLASSE Region ------------------
//------------------------------------------------
//----------------------------------------------------------
// constructeur de la classe Regions  
//----------------------------------------------------------
 SetRegion::SetRegion(int** matrice,int Length,int Width,int szm) 
 { 
  int i,j;

  //--init. Longeur/Largeur --
  width=Width; length=Length;
  nbmax_regions=width*length;
  size_max=szm;
  nb_regions=0;

  //--Allocation memoire region  --
  pp_region=new region*[nbmax_regions];
 
  //--init matrice --
  mat=imatrix_allocate_2d(length,width);
  mat_tmp=imatrix_allocate_2d(length,width);
  mat_belonging=imatrix_allocate_2d(length,width);
  mat_coul=imatrix_allocate_3d(TROIS,length,width);

  //--copie matrice --
  for(i=0;i<length;i++)  for(j=0;j<width;j++) 
     { mat[i][j]=matrice[i][j];
       mat_tmp[i][j]=matrice[i][j]; }

  //--init flag --
  flag_ssilent=0;
 }

//----------------------------------------------------------
// constructeur de la classe Regions  
//----------------------------------------------------------
 SetRegion::SetRegion(float** matrice,int Length,int Width,int szm) 
 { 
  int i,j;

  //--init. Longeur/Largeur --
  width=Width; length=Length;
  nbmax_regions=width*length;
  size_max=szm;
  nb_regions=0;

  //--Allocation memoire region  --
  pp_region=new region*[nbmax_regions];
 
  //--init matrice --
  mat=imatrix_allocate_2d(length,width);
  mat_tmp=imatrix_allocate_2d(length,width);
  mat_belonging=imatrix_allocate_2d(length,width);
  mat_coul=imatrix_allocate_3d(TROIS,length,width);

  //--copie matrice --
  for(i=0;i<length;i++)  for(j=0;j<width;j++) 
     { mat[i][j]=(int)matrice[i][j];
       mat_tmp[i][j]=(int)matrice[i][j]; }

  //--init flag --
  flag_ssilent=0;
 }

//----------------------------------------------------------
// destructeur de la classe Region 
//----------------------------------------------------------
 SetRegion::~SetRegion()
 { 
  int k;

   //--Liberation memoire --
   for(k=0;k<nb_regions;k++)  free_imatrix_2d(pp_region[k]->pixs);
   for(k=0;k<nb_regions;k++)  delete(pp_region[k]);
   delete[] pp_region;

   free_imatrix_2d(mat); 
   free_imatrix_2d(mat_tmp);
   free_imatrix_2d(mat_belonging);
   free_imatrix_3d(mat_coul,TROIS);
 }

//----------------------------------------------------------
// trouve les regions
//----------------------------------------------------------
void SetRegion::find_regions()
 {
   int i,j,k,l;
   int classe;
   int nb;

   //Init
   nb=-1;
 
   for(i=0;i<length;i++) for(j=0;j<width;j++)
     {
      classe=mat_tmp[i][j];
      if (classe!=-1) 
         {
          //-Nelle Region
	  compteur_pixels=0;

          pp_region[nb_regions]=new region;
          pp_region[nb_regions]->pixs=imatrix_allocate_2d(DEUX,size_max);

          for(k=0;k<DEUX;k++) for(l=0;l<size_max;l++) pp_region[nb_regions]->pixs[k][l]=-1;

          pp_region[nb_regions]->nb_points=0;

          pp_region[nb_regions]->CoulR=(int)(randomize2()*255);
          pp_region[nb_regions]->CoulV=(int)(randomize2()*255);
          pp_region[nb_regions]->CoulB=(int)(randomize2()*255); 

          pp_region[nb_regions]->row_min=VERY_BIG_NUMBER;
          pp_region[nb_regions]->col_min=VERY_BIG_NUMBER;
          pp_region[nb_regions]->row_max=-VERY_BIG_NUMBER;
          pp_region[nb_regions]->col_max=-VERY_BIG_NUMBER;
          

          if (0) find_objet1(i,j,classe,nb_regions); 

          if (0) find_objetRandom(i,j,classe,nb_regions);

          if (1)                                              
	     { nb=(int)random_flo(3.5);
               if (nb==0) find_objet1(i,j,classe,nb_regions);
               if (nb==1) find_objet2(i,j,classe,nb_regions);
               if (nb==2) find_objet3(i,j,classe,nb_regions);
               if (nb==3) find_objet4(i,j,classe,nb_regions); }
       
          if (0)                                             
             { if (nb==-1) nb=(int)random_flo(3.5);
               if (nb==0) find_obj1(i,j,classe,nb_regions);
               if (nb==1) find_obj2(i,j,classe,nb_regions);
               if (nb==2) find_obj3(i,j,classe,nb_regions);
               if (nb==3) find_obj4(i,j,classe,nb_regions); 
             }          
      
          nb_regions++;
         }
     }
 }


//-----------//
//-- UTILE --//
//-----------//
//----------------------------------------------------------
// find_obj1 <vertical>
//----------------------------------------------------------
void SetRegion::find_obj1(int row,int col,int cl,int nbreg)
{
 if (mat_tmp[row][col]==cl)
    {
     mat_tmp[row][col]=-1;
   
     compteur_pixels++;
     pp_region[nbreg]->pixs[0][compteur_pixels-1]=row;
     pp_region[nbreg]->pixs[1][compteur_pixels-1]=col;
     pp_region[nb_regions]->nb_points=compteur_pixels;

     if (row<pp_region[nb_regions]->row_min) pp_region[nb_regions]->row_min=row;
     if (col<pp_region[nb_regions]->col_min) pp_region[nb_regions]->col_min=col;
     if (row>pp_region[nb_regions]->row_max) pp_region[nb_regions]->row_max=row;
     if (col>pp_region[nb_regions]->col_max) pp_region[nb_regions]->col_max=col;  

     //Enregistrement dans matrice
     mat_belonging[row][col]=nbreg;
 
     //Recherche recursive
     if ((compteur_pixels<(size_max-1))&&((row+1)<length))  find_obj1(row+1,col,cl,nbreg); 
    }
}

//----------------------------------------------------------
// find_obj2 <horizontal>
//----------------------------------------------------------
void SetRegion::find_obj2(int row,int col,int cl,int nbreg)
{
 if (mat_tmp[row][col]==cl)
    {
     mat_tmp[row][col]=-1;
   
     compteur_pixels++;
     pp_region[nbreg]->pixs[0][compteur_pixels-1]=row;
     pp_region[nbreg]->pixs[1][compteur_pixels-1]=col;
     pp_region[nb_regions]->nb_points=compteur_pixels;

     if (row<pp_region[nb_regions]->row_min) pp_region[nb_regions]->row_min=row;
     if (col<pp_region[nb_regions]->col_min) pp_region[nb_regions]->col_min=col;
     if (row>pp_region[nb_regions]->row_max) pp_region[nb_regions]->row_max=row;
     if (col>pp_region[nb_regions]->col_max) pp_region[nb_regions]->col_max=col;  

     //Enregistrement dans matrice
     mat_belonging[row][col]=nbreg;
 
     //Recherche recursive
     if ((compteur_pixels<(size_max-1))&&((col+1)<width))   find_obj2(row,col+1,cl,nbreg);
     
    }
}

//----------------------------------------------------------
// find_obj3 <diagonal droite>
//----------------------------------------------------------
void SetRegion::find_obj3(int row,int col,int cl,int nbreg)
{
 if (mat_tmp[row][col]==cl)
    {
     mat_tmp[row][col]=-1;
   
     compteur_pixels++;
     pp_region[nbreg]->pixs[0][compteur_pixels-1]=row;
     pp_region[nbreg]->pixs[1][compteur_pixels-1]=col;
     pp_region[nb_regions]->nb_points=compteur_pixels;

     if (row<pp_region[nb_regions]->row_min) pp_region[nb_regions]->row_min=row;
     if (col<pp_region[nb_regions]->col_min) pp_region[nb_regions]->col_min=col;
     if (row>pp_region[nb_regions]->row_max) pp_region[nb_regions]->row_max=row;
     if (col>pp_region[nb_regions]->col_max) pp_region[nb_regions]->col_max=col;  

     //Enregistrement dans matrice
     mat_belonging[row][col]=nbreg;
 
     //Recherche recursive
     if ((compteur_pixels<(size_max-1))&&((row+1)<length)&&((col+1)<width))  
        find_obj3(row+1,col+1,cl,nbreg); 
    }
}

//----------------------------------------------------------
// find_obj4 <diagonale gauche>
//----------------------------------------------------------
void SetRegion::find_obj4(int row,int col,int cl,int nbreg)
{
 if (mat_tmp[row][col]==cl)
    {
     mat_tmp[row][col]=-1;
   
     compteur_pixels++;
     pp_region[nbreg]->pixs[0][compteur_pixels-1]=row;
     pp_region[nbreg]->pixs[1][compteur_pixels-1]=col;
     pp_region[nb_regions]->nb_points=compteur_pixels;

     if (row<pp_region[nb_regions]->row_min) pp_region[nb_regions]->row_min=row;
     if (col<pp_region[nb_regions]->col_min) pp_region[nb_regions]->col_min=col;
     if (row>pp_region[nb_regions]->row_max) pp_region[nb_regions]->row_max=row;
     if (col>pp_region[nb_regions]->col_max) pp_region[nb_regions]->col_max=col;  

     //Enregistrement dans matrice
     mat_belonging[row][col]=nbreg;
 
     //Recherche recursive
     if ((compteur_pixels<(size_max-1))&&((row+1)<length)&&((col-1)>0))   
        find_obj4(row+1,col-1,cl,nbreg); 
    }
}

//----------------------------------------------------------
// find_objet Random
//----------------------------------------------------------
void SetRegion::find_objetRandom(int row,int col,int cl,int nbreg)
{
 int k;
 int nb;
 int vct[8];

 //Init
 for(k=0;k<8;k++) vct[k]=0;


 //Recursive Aleatory Search
 //-------------------------
 if (mat_tmp[row][col]==cl)
    {
     mat_tmp[row][col]=-1;
   
     compteur_pixels++;
     pp_region[nbreg]->pixs[0][compteur_pixels-1]=row;
     pp_region[nbreg]->pixs[1][compteur_pixels-1]=col;
     pp_region[nb_regions]->nb_points=compteur_pixels;

     if (row<pp_region[nb_regions]->row_min) pp_region[nb_regions]->row_min=row;
     if (col<pp_region[nb_regions]->col_min) pp_region[nb_regions]->col_min=col;
     if (row>pp_region[nb_regions]->row_max) pp_region[nb_regions]->row_max=row;
     if (col>pp_region[nb_regions]->col_max) pp_region[nb_regions]->col_max=col;  

     //Enregistrement dans matrice
     mat_belonging[row][col]=nbreg;
 
     //Recherche recursive aleatoire
     for(k=0;k<8;k++)
        {
	 //Nb Aleat
	  for(;;)
                {       
                 nb=(int)random_flo(7.5);  
                 if (!vct[nb]) { vct[nb]=1; break; }
                }

         if (((compteur_pixels<(size_max-1))&&((col-1)>0))&&(nb==0))         find_objetRandom(row,col-1,cl,nbreg); 
         if (((compteur_pixels<(size_max-1))&&((row-1)>0))&&(nb==1))         find_objetRandom(row-1,col,cl,nbreg); 
         if (((compteur_pixels<(size_max-1))&&((col+1)<width))&&(nb==2))     find_objetRandom(row,col+1,cl,nbreg); 
         if (((compteur_pixels<(size_max-1))&&((row+1)<length))&&(nb==3))    find_objetRandom(row+1,col,cl,nbreg); 
       
         if (((compteur_pixels<(size_max-1))&&((row-1)>0)&&((col-1)>0))&&(nb==4))       
            find_objetRandom(row-1,col-1,cl,nbreg); 

         if (((compteur_pixels<(size_max-1))&&((row+1)<length)&&((col+1)<width))&&(nb==5))    
            find_objetRandom(row+1,col+1,cl,nbreg); 

         if (((compteur_pixels<(size_max-1))&&((row-1)>0)&&((col+1)<width))&&(nb==6))       
            find_objetRandom(row-1,col+1,cl,nbreg); 

         if (((compteur_pixels<(size_max-1))&&((row+1)<length)&&((col-1)>0))&&(nb==7))    
            find_objetRandom(row+1,col-1,cl,nbreg); 
	}
    }
}

//-----------//
//-- UTILE --//
//-----------//
//----------------------------------------------------------
// find_objet1 vertical
//----------------------------------------------------------
void SetRegion::find_objet1(int row,int col,int cl,int nbreg)
{
 if (mat_tmp[row][col]==cl)
    {
     mat_tmp[row][col]=-1;
   
     compteur_pixels++;
     pp_region[nbreg]->pixs[0][compteur_pixels-1]=row;
     pp_region[nbreg]->pixs[1][compteur_pixels-1]=col;
     pp_region[nb_regions]->nb_points=compteur_pixels;

     if (row<pp_region[nb_regions]->row_min) pp_region[nb_regions]->row_min=row;
     if (col<pp_region[nb_regions]->col_min) pp_region[nb_regions]->col_min=col;
     if (row>pp_region[nb_regions]->row_max) pp_region[nb_regions]->row_max=row;
     if (col>pp_region[nb_regions]->col_max) pp_region[nb_regions]->col_max=col;  

     //Enregistrement dans matrice
     mat_belonging[row][col]=nbreg;
 
     //Recherche recursive
     if ((compteur_pixels<(size_max-1))&&((row-1)>0))       find_objet1(row-1,col,cl,nbreg); 
     if ((compteur_pixels<(size_max-1))&&((row+1)<length))  find_objet1(row+1,col,cl,nbreg); 
     if ((compteur_pixels<(size_max-1))&&((col-1)>0))       find_objet1(row,col-1,cl,nbreg); 
     if ((compteur_pixels<(size_max-1))&&((col+1)<width))   find_objet1(row,col+1,cl,nbreg);  
    
     if ((compteur_pixels<(size_max-1))&&((row-1)>0)&&((col-1)>0))       
        find_objet1(row-1,col-1,cl,nbreg); 

     if ((compteur_pixels<(size_max-1))&&((row+1)<length)&&((col+1)<width))  
        find_objet1(row+1,col+1,cl,nbreg); 

     if ((compteur_pixels<(size_max-1))&&((row-1)>0)&&((col+1)<width))       
        find_objet1(row-1,col+1,cl,nbreg); 

     if ((compteur_pixels<(size_max-1))&&((row+1)<length)&&((col-1)>0))   
        find_objet1(row+1,col-1,cl,nbreg); 
    }
}

//----------------------------------------------------------
// find_objet2 horizontal
//----------------------------------------------------------
void SetRegion::find_objet2(int row,int col,int cl,int nbreg)
{
 if (mat_tmp[row][col]==cl)
    {
     mat_tmp[row][col]=-1;
   
     compteur_pixels++;
     pp_region[nbreg]->pixs[0][compteur_pixels-1]=row;
     pp_region[nbreg]->pixs[1][compteur_pixels-1]=col;
     pp_region[nb_regions]->nb_points=compteur_pixels;

     if (row<pp_region[nb_regions]->row_min) pp_region[nb_regions]->row_min=row;
     if (col<pp_region[nb_regions]->col_min) pp_region[nb_regions]->col_min=col;
     if (row>pp_region[nb_regions]->row_max) pp_region[nb_regions]->row_max=row;
     if (col>pp_region[nb_regions]->col_max) pp_region[nb_regions]->col_max=col;  

     //Enregistrement dans matrice
     mat_belonging[row][col]=nbreg;
 
     //Recherche recursive
     if ((compteur_pixels<(size_max-1))&&((col-1)>0))       find_objet2(row,col-1,cl,nbreg); 
     if ((compteur_pixels<(size_max-1))&&((col+1)<width))   find_objet2(row,col+1,cl,nbreg);
     if ((compteur_pixels<(size_max-1))&&((row-1)>0))       find_objet2(row-1,col,cl,nbreg); 
     if ((compteur_pixels<(size_max-1))&&((row+1)<length))  find_objet2(row+1,col,cl,nbreg);    
    
     if ((compteur_pixels<(size_max-1))&&((row-1)>0)&&((col-1)>0))       
        find_objet2(row-1,col-1,cl,nbreg); 

     if ((compteur_pixels<(size_max-1))&&((row+1)<length)&&((col+1)<width))  
        find_objet2(row+1,col+1,cl,nbreg); 

     if ((compteur_pixels<(size_max-1))&&((row-1)>0)&&((col+1)<width))       
        find_objet2(row-1,col+1,cl,nbreg); 

     if ((compteur_pixels<(size_max-1))&&((row+1)<length)&&((col-1)>0))   
        find_objet2(row+1,col-1,cl,nbreg); 
    }
}

//----------------------------------------------------------
// find_objet3 diagonal droite
//----------------------------------------------------------
void SetRegion::find_objet3(int row,int col,int cl,int nbreg)
{
 if (mat_tmp[row][col]==cl)
    {
     mat_tmp[row][col]=-1;
   
     compteur_pixels++;
     pp_region[nbreg]->pixs[0][compteur_pixels-1]=row;
     pp_region[nbreg]->pixs[1][compteur_pixels-1]=col;
     pp_region[nb_regions]->nb_points=compteur_pixels;

     if (row<pp_region[nb_regions]->row_min) pp_region[nb_regions]->row_min=row;
     if (col<pp_region[nb_regions]->col_min) pp_region[nb_regions]->col_min=col;
     if (row>pp_region[nb_regions]->row_max) pp_region[nb_regions]->row_max=row;
     if (col>pp_region[nb_regions]->col_max) pp_region[nb_regions]->col_max=col;  

     //Enregistrement dans matrice
     mat_belonging[row][col]=nbreg;
 
     //Recherche recursive
     if ((compteur_pixels<(size_max-1))&&((row-1)>0))       find_objet3(row-1,col,cl,nbreg); 
     if ((compteur_pixels<(size_max-1))&&((col-1)>0))       find_objet3(row,col-1,cl,nbreg);
     if ((compteur_pixels<(size_max-1))&&((row+1)<length))  find_objet3(row+1,col,cl,nbreg);    
     if ((compteur_pixels<(size_max-1))&&((col+1)<width))   find_objet3(row,col+1,cl,nbreg);  
    
     if ((compteur_pixels<(size_max-1))&&((row-1)>0)&&((col-1)>0))       
        find_objet3(row-1,col-1,cl,nbreg); 

     if ((compteur_pixels<(size_max-1))&&((row+1)<length)&&((col+1)<width))  
        find_objet3(row+1,col+1,cl,nbreg); 

     if ((compteur_pixels<(size_max-1))&&((row-1)>0)&&((col+1)<width))       
        find_objet3(row-1,col+1,cl,nbreg); 

     if ((compteur_pixels<(size_max-1))&&((row+1)<length)&&((col-1)>0))   
        find_objet3(row+1,col-1,cl,nbreg); 
    }
}

//----------------------------------------------------------
// find_objet4 diagonale gauche
//----------------------------------------------------------
void SetRegion::find_objet4(int row,int col,int cl,int nbreg)
{
 if (mat_tmp[row][col]==cl)
    {
     mat_tmp[row][col]=-1;
   
     compteur_pixels++;
     pp_region[nbreg]->pixs[0][compteur_pixels-1]=row;
     pp_region[nbreg]->pixs[1][compteur_pixels-1]=col;
     pp_region[nb_regions]->nb_points=compteur_pixels;

     if (row<pp_region[nb_regions]->row_min) pp_region[nb_regions]->row_min=row;
     if (col<pp_region[nb_regions]->col_min) pp_region[nb_regions]->col_min=col;
     if (row>pp_region[nb_regions]->row_max) pp_region[nb_regions]->row_max=row;
     if (col>pp_region[nb_regions]->col_max) pp_region[nb_regions]->col_max=col;  

     //Enregistrement dans matrice
     mat_belonging[row][col]=nbreg;
 
     //Recherche recursive
     if ((compteur_pixels<(size_max-1))&&((col-1)>0))       find_objet4(row,col-1,cl,nbreg); 
     if ((compteur_pixels<(size_max-1))&&((row-1)>0))       find_objet4(row-1,col,cl,nbreg); 
     if ((compteur_pixels<(size_max-1))&&((col+1)<width))   find_objet4(row,col+1,cl,nbreg); 
     if ((compteur_pixels<(size_max-1))&&((row+1)<length))  find_objet4(row+1,col,cl,nbreg); 
       
     if ((compteur_pixels<(size_max-1))&&((row-1)>0)&&((col-1)>0))       
        find_objet4(row-1,col-1,cl,nbreg); 

     if ((compteur_pixels<(size_max-1))&&((row+1)<length)&&((col+1)<width))  
        find_objet4(row+1,col+1,cl,nbreg); 

     if ((compteur_pixels<(size_max-1))&&((row-1)>0)&&((col+1)<width))       
        find_objet4(row-1,col+1,cl,nbreg); 

     if ((compteur_pixels<(size_max-1))&&((row+1)<length)&&((col-1)>0))   
        find_objet4(row+1,col-1,cl,nbreg); 
    }
}


//-----------------//
//-- VISU & STATS--//
//-----------------//
//----------------------------------------------------------
// stat sur les differentes regions
//----------------------------------------------------------
void SetRegion::stat_regions()
 {
  int k;
  int size;
  float sum;
  float min,max,moy,nb_reg1pix;

  if (!flag_ssilent)
     { printf("\n\n");
       printf("\n -------------------");
       printf("\n -- STATS REGIONS --");
       printf("\n -------------------"); }

  //Init
  min=VERY_BIG_NUMBER;
  max=-VERY_BIG_NUMBER;

  sum=0;
  moy=0;
  nb_reg1pix=0;

  //-Boucle
  for(k=0;k<nb_regions;k++)
    {
     size=pp_region[k]->nb_points;
     sum+=size;
     if (size<min) min=size;
     if (size>max) max=size; 
     if (size==1)  nb_reg1pix++;
    }

  //-Stat
  size_moy_obj=sum/nb_regions;
  size_min_obj=min;
  size_max_obj=max;
  nb_regions_1pix=nb_reg1pix;

  //Affichage
  if (!flag_ssilent)
     { printf("\n\n Nb Regions = %d",nb_regions);
       printf("\n Taille:  Min=%.1f  -  Max=%.1f  -  Moy=%.1f",size_min_obj,size_max_obj,size_moy_obj);
       printf("\n Nb regions d'1 pixel = %.0f",nb_regions_1pix);
       printf("\n"); }
 }

//----------------------------------------------------------
// fill_mat_color
//----------------------------------------------------------
void SetRegion::fill_mat_color()
{
  int i,k;
  int row,col;

  for(k=0;k<nb_regions;k++)
    {
     for(i=0;i<pp_region[k]->nb_points;i++)
	  {
	   row=pp_region[k]->pixs[0][i];
           col=pp_region[k]->pixs[1][i];

	   mat_coul[0][row][col]=pp_region[k]->CoulR;
           mat_coul[1][row][col]=pp_region[k]->CoulV;
           mat_coul[2][row][col]=pp_region[k]->CoulB;
          }
    }
}

//----------------------------------------------------------
// 
//----------------------------------------------------------










 
